Index: bsps/arm/lpc176x/config/lpc1768_mbed-testsuite.tcfg
===================================================================
--- bsps/arm/lpc176x/config/lpc1768_mbed-testsuite.tcfg	(revision 5ff61810bc98e1f68ab1b20afcfac96547618fb3)
+++ bsps/arm/lpc176x/config/lpc1768_mbed-testsuite.tcfg	(revision 6016894e0c8e107a4f87714f3b0d86bf9822d4df)
@@ -8,14 +8,79 @@
 include: testdata/disable-jffs2-tests.tcfg
 
+exclude: block08
+exclude: capture
 exclude: dl07
+exclude: dl08
+exclude: dl09
+exclude: fileio
 exclude: flashdisk01
+exclude: fsdosfsname01
 exclude: ftp01
-exclude: utf8proc01
+exclude: linpack
+exclude: loopback
+exclude: mghttpd01
+exclude: pppd
+exclude: psxaio01
+exclude: psxaio02
+exclude: psxaio03
+exclude: psxconfig01
+exclude: psxtmbarrier02
+exclude: psxtmclocknanosleep02
+exclude: psxtmclocknanosleep03
+exclude: psxtmcond08
+exclude: psxtmcond09
+exclude: psxtmcond10
+exclude: psxtmmqrcvblock01
+exclude: psxtmmqrcvblock02
+exclude: psxtmmutex02
+exclude: psxtmmutex04
+exclude: psxtmmutex06
+exclude: psxtmnanosleep02
+exclude: psxtmrwlock02
+exclude: psxtmrwlock03
+exclude: psxtmrwlock04
+exclude: psxtmrwlock05
+exclude: psxtmrwlock07
+exclude: psxtmsem03
+exclude: psxtmsem05
+exclude: psxtmsleep02
+exclude: psxtmthread01
+exclude: psxtmthread03
+exclude: sp16
+exclude: sp25
+exclude: sp42
+exclude: sp47
+exclude: sp48
+exclude: sp71
 exclude: spstkalloc02
-exclude: fsdosfsname01
-exclude: linpack
-exclude: pppd
-exclude: mghttpd01
-exclude: tmfine01
-exclude: iostream
-exclude: rtems++
+exclude: sptimecounter02
+exclude: sptimecounter03
+exclude: tm02
+exclude: tm03
+exclude: tm04
+exclude: tm05
+exclude: tm06
+exclude: tm07
+exclude: tm10
+exclude: tm11
+exclude: tm12
+exclude: tm13
+exclude: tm14
+exclude: tm15
+exclude: tm16
+exclude: tm17
+exclude: tm18
+exclude: tm21
+exclude: tm23
+exclude: tm24
+exclude: tm25
+exclude: tm26
+exclude: tm29
+exclude: tm31
+exclude: tm32
+exclude: tm33
+exclude: tm34
+exclude: tm35
+exclude: tm36
+exclude: tmcontext01
+exclude: top
Index: bsps/arm/lpc176x/config/lpc1768_mbed_ahb_ram-testsuite.tcfg
===================================================================
--- bsps/arm/lpc176x/config/lpc1768_mbed_ahb_ram-testsuite.tcfg	(revision 5ff61810bc98e1f68ab1b20afcfac96547618fb3)
+++ bsps/arm/lpc176x/config/lpc1768_mbed_ahb_ram-testsuite.tcfg	(revision 6016894e0c8e107a4f87714f3b0d86bf9822d4df)
@@ -8,15 +8,79 @@
 include: testdata/disable-jffs2-tests.tcfg
 
+exclude: block08
+exclude: capture
 exclude: dl07
+exclude: dl08
+exclude: dl09
+exclude: fileio
 exclude: flashdisk01
 exclude: fsdosfsname01
 exclude: ftp01
 exclude: linpack
+exclude: loopback
 exclude: mghttpd01
 exclude: pppd
+exclude: psxaio01
+exclude: psxaio02
+exclude: psxaio03
+exclude: psxconfig01
+exclude: psxtmbarrier02
+exclude: psxtmclocknanosleep02
+exclude: psxtmclocknanosleep03
+exclude: psxtmcond08
+exclude: psxtmcond09
+exclude: psxtmcond10
+exclude: psxtmmqrcvblock01
+exclude: psxtmmqrcvblock02
+exclude: psxtmmutex02
+exclude: psxtmmutex04
+exclude: psxtmmutex06
+exclude: psxtmnanosleep02
+exclude: psxtmrwlock02
+exclude: psxtmrwlock03
+exclude: psxtmrwlock04
+exclude: psxtmrwlock05
+exclude: psxtmrwlock07
+exclude: psxtmsem03
+exclude: psxtmsem05
+exclude: psxtmsleep02
+exclude: psxtmthread01
+exclude: psxtmthread03
+exclude: sp16
+exclude: sp25
+exclude: sp42
+exclude: sp47
+exclude: sp48
+exclude: sp71
 exclude: spstkalloc02
-exclude: sptls02
-exclude: tmfine01
-exclude: utf8proc01
-exclude: iostream
-exclude: rtems++
+exclude: sptimecounter02
+exclude: sptimecounter03
+exclude: tm02
+exclude: tm03
+exclude: tm04
+exclude: tm05
+exclude: tm06
+exclude: tm07
+exclude: tm10
+exclude: tm11
+exclude: tm12
+exclude: tm13
+exclude: tm14
+exclude: tm15
+exclude: tm16
+exclude: tm17
+exclude: tm18
+exclude: tm21
+exclude: tm23
+exclude: tm24
+exclude: tm25
+exclude: tm26
+exclude: tm29
+exclude: tm31
+exclude: tm32
+exclude: tm33
+exclude: tm34
+exclude: tm35
+exclude: tm36
+exclude: tmcontext01
+exclude: top
Index: bsps/arm/lpc176x/config/lpc1768_mbed_ahb_ram_eth-testsuite.tcfg
===================================================================
--- bsps/arm/lpc176x/config/lpc1768_mbed_ahb_ram_eth-testsuite.tcfg	(revision 5ff61810bc98e1f68ab1b20afcfac96547618fb3)
+++ bsps/arm/lpc176x/config/lpc1768_mbed_ahb_ram_eth-testsuite.tcfg	(revision 6016894e0c8e107a4f87714f3b0d86bf9822d4df)
@@ -8,26 +8,79 @@
 include: testdata/disable-jffs2-tests.tcfg
 
+exclude: block08
+exclude: capture
 exclude: dl07
+exclude: dl08
+exclude: dl09
 exclude: fileio
-exclude: ftp01
-exclude: cdtest
 exclude: flashdisk01
 exclude: fsdosfsname01
+exclude: ftp01
 exclude: linpack
+exclude: loopback
 exclude: mghttpd01
-exclude: monitor01
-exclude: monitor02
 exclude: pppd
+exclude: psxaio01
+exclude: psxaio02
+exclude: psxaio03
 exclude: psxconfig01
-exclude: rbheap01
+exclude: psxtmbarrier02
+exclude: psxtmclocknanosleep02
+exclude: psxtmclocknanosleep03
+exclude: psxtmcond08
+exclude: psxtmcond09
+exclude: psxtmcond10
+exclude: psxtmmqrcvblock01
+exclude: psxtmmqrcvblock02
+exclude: psxtmmutex02
+exclude: psxtmmutex04
+exclude: psxtmmutex06
+exclude: psxtmnanosleep02
+exclude: psxtmrwlock02
+exclude: psxtmrwlock03
+exclude: psxtmrwlock04
+exclude: psxtmrwlock05
+exclude: psxtmrwlock07
+exclude: psxtmsem03
+exclude: psxtmsem05
+exclude: psxtmsleep02
+exclude: psxtmthread01
+exclude: psxtmthread03
 exclude: sp16
 exclude: sp25
+exclude: sp42
+exclude: sp47
 exclude: sp48
-exclude: spregion_err01
-exclude: spstkalloc
+exclude: sp71
 exclude: spstkalloc02
-exclude: sptls02
-exclude: tmfine01
-exclude: utf8proc01
-exclude: iostream
-exclude: rtems++
+exclude: sptimecounter02
+exclude: sptimecounter03
+exclude: tm02
+exclude: tm03
+exclude: tm04
+exclude: tm05
+exclude: tm06
+exclude: tm07
+exclude: tm10
+exclude: tm11
+exclude: tm12
+exclude: tm13
+exclude: tm14
+exclude: tm15
+exclude: tm16
+exclude: tm17
+exclude: tm18
+exclude: tm21
+exclude: tm23
+exclude: tm24
+exclude: tm25
+exclude: tm26
+exclude: tm29
+exclude: tm31
+exclude: tm32
+exclude: tm33
+exclude: tm34
+exclude: tm35
+exclude: tm36
+exclude: tmcontext01
+exclude: top