Index: c/src/tests/samples/ChangeLog
===================================================================
--- c/src/tests/samples/ChangeLog	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/ChangeLog	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -1,2 +1,9 @@
+2000-09-04	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* base_mp/node1/Makefile.am, base_mp/node2/Makefile.am,
+	base_sp/Makefile.am, cdtest/Makefile.am, hello/Makefile.am,
+	minimum/Makefile.am, paranoia/Makefile.am, ticker/Makefile.am,
+	unlimited/Makefile.am: Include compile.am
+
 2000-08-10	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/tests/samples/base_mp/node1/Makefile.am
===================================================================
--- c/src/tests/samples/base_mp/node1/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/base_mp/node1/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -27,4 +27,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/base_mp/node2/Makefile.am
===================================================================
--- c/src/tests/samples/base_mp/node2/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/base_mp/node2/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -27,4 +27,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/base_sp/Makefile.am
===================================================================
--- c/src/tests/samples/base_sp/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/base_sp/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/cdtest/Makefile.am
===================================================================
--- c/src/tests/samples/cdtest/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/cdtest/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -28,4 +28,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/hello/Makefile.am
===================================================================
--- c/src/tests/samples/hello/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/hello/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/minimum/Makefile.am
===================================================================
--- c/src/tests/samples/minimum/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/minimum/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -22,4 +22,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/paranoia/Makefile.am
===================================================================
--- c/src/tests/samples/paranoia/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/paranoia/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/ticker/Makefile.am
===================================================================
--- c/src/tests/samples/ticker/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/ticker/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: c/src/tests/samples/unlimited/Makefile.am
===================================================================
--- c/src/tests/samples/unlimited/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ c/src/tests/samples/unlimited/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/ChangeLog
===================================================================
--- testsuites/samples/ChangeLog	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/ChangeLog	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -1,2 +1,9 @@
+2000-09-04	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* base_mp/node1/Makefile.am, base_mp/node2/Makefile.am,
+	base_sp/Makefile.am, cdtest/Makefile.am, hello/Makefile.am,
+	minimum/Makefile.am, paranoia/Makefile.am, ticker/Makefile.am,
+	unlimited/Makefile.am: Include compile.am
+
 2000-08-10	Joel Sherrill <joel@OARcorp.com>
 
Index: testsuites/samples/base_mp/node1/Makefile.am
===================================================================
--- testsuites/samples/base_mp/node1/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/base_mp/node1/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -27,4 +27,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/base_mp/node2/Makefile.am
===================================================================
--- testsuites/samples/base_mp/node2/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/base_mp/node2/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -27,4 +27,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/base_sp/Makefile.am
===================================================================
--- testsuites/samples/base_sp/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/base_sp/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/cdtest/Makefile.am
===================================================================
--- testsuites/samples/cdtest/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/cdtest/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -28,4 +28,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/hello/Makefile.am
===================================================================
--- testsuites/samples/hello/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/hello/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/minimum/Makefile.am
===================================================================
--- testsuites/samples/minimum/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/minimum/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -22,4 +22,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/paranoia/Makefile.am
===================================================================
--- testsuites/samples/paranoia/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/paranoia/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/ticker/Makefile.am
===================================================================
--- testsuites/samples/ticker/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/ticker/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am
Index: testsuites/samples/unlimited/Makefile.am
===================================================================
--- testsuites/samples/unlimited/Makefile.am	(revision c4f610387f4499ad8a1a1dea50e9af0b8c4a3bc3)
+++ testsuites/samples/unlimited/Makefile.am	(revision 6212465d03f89b0a45188d47920e5a4acb6e6875)
@@ -25,4 +25,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../automake/compile.am
 include $(RTEMS_ROOT)/make/leaf.cfg
 include $(top_srcdir)/sample.am