Index: eng/appendix-a.rst
===================================================================
--- eng/appendix-a.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/appendix-a.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -10,5 +10,5 @@
 An effort at NASA has been performed to suggest a core set of artifacts
 (as defined by **BOTH** NASA NPR 7150.2B and DO-178B) that can be utilized
-by a mission as a baselined starting point for âpre-qualificationâ
+by a mission as a baselined starting point for "pre-qualification"
 for (open-source) software that is intended to be utilized for flight
 purposes.  This effort analyzed the overlap between NPR 7150.2B
@@ -127,5 +127,5 @@
    |                |                       | verification activities.        |
    +----------------+-----------------------+---------------------------------+
-   | Usability      | Software Userâs       | The Software User Manual        |
+   | Usability      | Software User's       | The Software User Manual        |
    |                | Manual                | defines user instructions for   |
    |                |                       | the software.                   |
@@ -134,5 +134,5 @@
 In an effort to remain lightweight and sustainable for open-source
 projects, Table 1 above was condensed into a single artifact outline
-that encompasses the artifactsâ intents.  The idea is that this living
+that encompasses the artifacts' intents.  The idea is that this living
 qualification document will reside under RTEMS source control and be
 updated with additional detail accordingly.  The artifact outline is
Index: eng/license-requirements.rst
===================================================================
--- eng/license-requirements.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/license-requirements.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -10,5 +10,5 @@
 All artifacts shall adhere to RTEMS Project licensing
 requirements. Currently, the preferred licenses are CC-BY-SA-4.0 license
-for documentation and âTwo Paragraph BSDâ for source code.
+for documentation and "Two Paragraph BSD" for source code.
 
 Historically, RTEMS has been licensed under the GPL v2 with linking
Index: eng/prequalification.rst
===================================================================
--- eng/prequalification.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/prequalification.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -15,11 +15,11 @@
 standards typically do not specify software functionality but address
 topics like requirements definition, traceability, having a documented
-change process, coding style, testing requirements, and a userâs
-manual. During system test, these standards call for a review â usually
-by an independent entity â that the standard has been adhered too. These
+change process, coding style, testing requirements, and a user's
+manual. During system test, these standards call for a review - usually
+by an independent entity - that the standard has been adhered too. These
 reviews cover a broad variety of topics and activities, but the process
 is generally referred to as qualification, verification, or auditing
 against the specific standard in use. The RTEMS Project will use the
-term âqualificationâ independent of the standard.
+term "qualification" independent of the standard.
 
 The goal of the RTEMS Qualification Project is to make RTEMS easier
@@ -37,6 +37,6 @@
 
 The RTEMS Qualification Project is technically
-âpre-qualificationâ. True qualification must be performed on the
-projectâs target hardware in a system context. The FAA has provided
+"pre-qualification." True qualification must be performed on the
+project's target hardware in a system context. The FAA has provided
 guidance for Reusable Software Components (FAA-AC20-148) and this
 effort should follow that guidance. The open RTEMS Project, with the
@@ -54,5 +54,5 @@
 on qualification should be able to provide resources for improving the
 automated project infrastructure and master technical data for RTEMS. The
-term âresourcesâ is often used by open source projects to refer to
+term "resources" is often used by open source projects to refer to
 volunteer code contributions or funding. Although code contributions in
 this area are important and always welcome, funding is also important. At
@@ -75,5 +75,5 @@
 It is expected that the RTEMS Qualification Project will create and
 maintain maps from the RTEMS master technical data to the various
-qualification standards. It will maintain âscorecardsâ which
+qualification standards. It will maintain "scorecards" which
 identify how the RTEMS Project is currently doing when reviewed per each
 standard. These will be maintained in the open as community resources
Index: eng/test-plan.rst
===================================================================
--- eng/test-plan.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/test-plan.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -22,5 +22,5 @@
 Assuming that a requirements focused test suite is added to the open
 RTEMS, tools will be needed to assist in verifying that requirements are
-âfully tested.â A fully tested requirement is one which is implemented
+"fully tested." A fully tested requirement is one which is implemented
 and tested with associated logical tracing. Tools automating this analysis
 and generating reporting and alerts will be a critical part of ensuring
Index: eng/users-manuals.rst
===================================================================
--- eng/users-manuals.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/users-manuals.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -10,5 +10,5 @@
 TBD - write and link to useful documentation, potential URLs:
 
-Reference the RTEMS C Userâs Manual
+Reference the RTEMS Classic API Guide
 
 * https://docs.rtems.org/doc-current/share/rtems/pdf/c_user.pdf
Index: eng/vc-authors.rst
===================================================================
--- eng/vc-authors.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/vc-authors.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -26,7 +26,7 @@
 Currently all committer's should have an ssh account on the main git server,
 dispatch.rtems.org. If you have been granted commit access and do have an
-account on dispatch.rtems.org one should be requested on the devel@âŠ list.
+account on dispatch.rtems.org one should be requested on the devel@ list.
 SSH access for git uses key logins instead of passwords. The key should be at
-least 1024bits in length.
+least 1024 bits in length.
 
 The public repositories can by cloned with
@@ -43,5 +43,5 @@
 user with a personal repository can make commits, create and delete branches,
 plus more without interfering with the master repository. Commits to the
-master repository generate email to the vc@âŠ list and development type commits
+master repository generate email to the vc@ list and development type commits
 by a developer would only add noise and lessen the effectiveness of the commit
 list
Index: eng/vc-users.rst
===================================================================
--- eng/vc-users.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ eng/vc-users.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -385,5 +385,5 @@
 An alternative to the merge command is rebase, which replays the changes
 (commits) on one branch onto another. ``git rebase`` finds the common ancestor
-of the two branches, stores each commit of the branch youâre on to temporary
+of the two branches, stores each commit of the branch you are on to temporary
 files and applies each commit in order.
 
Index: user/tracing/examples.rst
===================================================================
--- user/tracing/examples.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ user/tracing/examples.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -57,5 +57,5 @@
 the full path instead of the path file: `sparc-rtems5/erc32/lib/` in the
 following commands according to your installation. Also confirm the path of the
-fileioâs executable and object files in the last line of the command according
+fileio's executable and object files in the last line of the command according
 to your installation.
 
Index: user/tracing/introduction.rst
===================================================================
--- user/tracing/introduction.rst	(revision e24c5e9682ee4d85474cbd326d25e99f0207731c)
+++ user/tracing/introduction.rst	(revision 6682434bf21f53d3bd64e0509b4df9524b17646a)
@@ -41,9 +41,9 @@
 used to build the application for performing this link.
 
-Step 2: The RTEMS Trace Linker reads the userâs configuration file and that
+Step 2: The RTEMS Trace Linker reads the user's configuration file and that
 results in it reading the standard Trace Buffering Configuration files
 installed with the RTEMS Trace Linker. The trace linker uses the target
 compiler and linker to create the trace enabled application executable. It
-wraps the functions defined in the userâs configuration with code that captures
+wraps the functions defined in the user's configuration with code that captures
 trace records into the statically allocated buffer. The trace wrapper code is
 compiled with the target compiler and the resulting ELF object file is added to
@@ -54,5 +54,5 @@
 the target hardware or simulator.
 
-Step 4: RTEMS shell provides the ârtraceâ command to display and save trace
+Step 4: RTEMS shell provides the "rtrace" command to display and save trace
 buffers.
 