Index: c/src/lib/libcpu/m68k/mcf5206/.cvsignore
===================================================================
--- c/src/lib/libcpu/m68k/mcf5206/.cvsignore	(revision 3d1de205f620197d40ad019eb2d9e2dd5f0525c2)
+++ c/src/lib/libcpu/m68k/mcf5206/.cvsignore	(revision 7023111e0a04e559ce72aad16b0c5b06c47ccc53)
@@ -1,14 +1,2 @@
-aclocal.m4
-autom4te*.cache
-config.cache
-config.guess
-config.log
-config.status
-config.sub
-configure
-depcomp
-install-sh
 Makefile
 Makefile.in
-missing
-mkinstalldirs
Index: c/src/lib/libcpu/m68k/mcf5206/Makefile.am
===================================================================
--- c/src/lib/libcpu/m68k/mcf5206/Makefile.am	(revision 3d1de205f620197d40ad019eb2d9e2dd5f0525c2)
+++ c/src/lib/libcpu/m68k/mcf5206/Makefile.am	(revision 7023111e0a04e559ce72aad16b0c5b06c47ccc53)
@@ -3,8 +3,12 @@
 ##
 
-ACLOCAL_AMFLAGS = -I ../../../../aclocal
+include $(top_srcdir)/../../../automake/compile.am
+include $(top_srcdir)/../../../automake/lib.am
 
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
+CLEANFILES =
+EXTRA_PROGRAMS =
+noinst_DATA =
+
+if mcf5206
 
 # include
@@ -14,82 +18,74 @@
 
 ## clock
+EXTRA_PROGRAMS += clock.rel
+CLEANFILES += clock.rel
+clock_rel_SOURCES = clock/ckinit.c
+clock_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+clock_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-clock_C_FILES = clock/ckinit.c
-clock_OBJS = $(clock_C_FILES:clock/%.c=clock/$(ARCH)/%.$(OBJEXT))
-EXTRA_DIST = $(clock_C_FILES)
+EXTRA_PROGRAMS += clock_g.rel
+CLEANFILES += clock_g.rel
+clock_g_rel_SOURCES = $(clock_rel_SOURCES)
+clock_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+clock_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-clock/$(ARCH)/$(dirstamp):
-	@$(mkdir_p) clock/$(ARCH)
-	@: > clock/$(ARCH)/$(dirstamp)
-clock/$(ARCH)/%.$(OBJEXT): clock/%.c clock/$(ARCH)/$(dirstamp)
-	${COMPILE} -o $@ -c $<
-clock/$(ARCH)/clock.rel: $(clock_OBJS)
-	$(make-rel)
-PGMS = clock/$(ARCH)/clock.rel
+noinst_DATA += clock$(LIB_VARIANT).rel
 
 ## console
+EXTRA_PROGRAMS += console.rel
+CLEANFILES += console.rel
+console_rel_SOURCES = console/mcfuart.c
+console_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+console_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-console_C_FILES = console/mcfuart.c
-console_OBJS = $(console_C_FILES:console/%.c=console/$(ARCH)/%.$(OBJEXT))
-EXTRA_DIST += $(console_C_FILES)
+EXTRA_PROGRAMS += console_g.rel
+CLEANFILES += console_g.rel
+console_g_rel_SOURCES = $(console_rel_SOURCES)
+console_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+console_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-console/$(ARCH)/$(dirstamp):
-	@$(mkdir_p) console/$(ARCH)
-	@: > console/$(ARCH)/$(dirstamp)
-console/$(ARCH)/%.$(OBJEXT): console/%.c console/$(ARCH)/$(dirstamp)
-	${COMPILE} -o $@ -c $<
-console/$(ARCH)/console.rel: $(console_OBJS)
-	$(make-rel)
-PGMS += console/$(ARCH)/console.rel
+noinst_DATA += console$(LIB_VARIANT).rel
 
 ## mbus
+EXTRA_PROGRAMS += mbus.rel
+CLEANFILES += mbus.rel
+mbus_rel_SOURCES = mbus/mcfmbus.c
+mbus_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+mbus_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-mbus_C_FILES = mbus/mcfmbus.c
-mbus_OBJS = $(mbus_C_FILES:mbus/%.c=mbus/$(ARCH)/%.$(OBJEXT))
-EXTRA_DIST += $(mbus_C_FILES)
+EXTRA_PROGRAMS += mbus_g.rel
+CLEANFILES += mbus_g.rel
+mbus_g_rel_SOURCES = $(mbus_rel_SOURCES)
+mbus_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+mbus_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-mbus/$(ARCH)/$(dirstamp):
-	@$(mkdir_p) mbus/$(ARCH)
-	@: > mbus/$(ARCH)/$(dirstamp)
-mbus/$(ARCH)/%.$(OBJEXT): mbus/%.c mbus/$(ARCH)/$(dirstamp)
-	${COMPILE} -o $@ -c $<
-mbus/$(ARCH)/mbus.rel: $(mbus_OBJS)
-	$(make-rel)
-PGMS += mbus/$(ARCH)/mbus.rel
+noinst_DATA += mbus$(LIB_VARIANT).rel
 
 ## timer
+EXTRA_PROGRAMS += timer.rel
+CLEANFILES += timer.rel
+timer_rel_SOURCES = timer/timer.c timer/timerisr.S
+timer_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+timer_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-timer_C_FILES = timer/timer.c
-timer_OBJS = $(timer_C_FILES:timer/%.c=timer/$(ARCH)/%.$(OBJEXT))
-EXTRA_DIST += $(timer_C_FILES)
+EXTRA_PROGRAMS += timer_g.rel
+CLEANFILES += timer_g.rel
+timer_g_rel_SOURCES = $(timer_rel_SOURCES)
+timer_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+timer_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-timer_S_FILES = timer/timerisr.S
-timer_OBJS += $(timer_S_FILES:timer/%.S=timer/$(ARCH)/%.$(OBJEXT))
-EXTRA_DIST += $(timer_S_FILES)
+noinst_DATA += timer$(LIB_VARIANT).rel
+endif
 
-timer/$(ARCH)/$(dirstamp):
-	@$(mkdir_p) timer/$(ARCH)
-	@: > timer/$(ARCH)/$(dirstamp)
-timer/$(ARCH)/%.$(OBJEXT): timer/%.c timer/$(ARCH)/$(dirstamp)
-	${COMPILE} -o $@ -c $<
-timer/$(ARCH)/%.o: timer/%.S timer/$(ARCH)/$(dirstamp)
-	${CCASCOMPILE} -DASM -o $@ -c $<
-timer/$(ARCH)/timer.rel: $(timer_OBJS)
-	$(make-rel)
-PGMS += timer/$(ARCH)/timer.rel
+all-local: $(PREINSTALL_FILES)
 
-## --
-
-all-local: $(PGMS)
-CLEANDIRS = */$(ARCH)
-
-.PRECIOUS: $(PGMS)
-
+PREINSTALL_DIRS =
 PREINSTALL_FILES =
 
+if mcf5206
 $(PROJECT_INCLUDE)/mcf5206/$(dirstamp):
 	@$(mkdir_p) $(PROJECT_INCLUDE)/mcf5206
 	@: > $(PROJECT_INCLUDE)/mcf5206/$(dirstamp)
-PREINSTALL_FILES += $(PROJECT_INCLUDE)/mcf5206/$(dirstamp)
+PREINSTALL_DIRS += $(PROJECT_INCLUDE)/mcf5206/$(dirstamp)
 
 $(PROJECT_INCLUDE)/mcf5206/mcf5206e.h: include/mcf5206e.h $(PROJECT_INCLUDE)/mcf5206/$(dirstamp)
@@ -104,6 +100,8 @@
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/mcf5206/mcfuart.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/mcf5206/mcfuart.h
+endif
 
-CLEANFILES = $(PREINSTALL_FILES)
+CLEANFILES += $(PREINSTALL_FILES)
+DISTCLEANFILES = $(PREINSTALL_DIRS)
 
-include $(top_srcdir)/../../../../automake/local.am
+include $(top_srcdir)/../../../automake/local.am
Index: src/lib/libcpu/m68k/mcf5206/configure.ac
===================================================================
--- c/src/lib/libcpu/m68k/mcf5206/configure.ac	(revision 3d1de205f620197d40ad019eb2d9e2dd5f0525c2)
+++ 	(revision )
@@ -1,29 +1,0 @@
-## Process this file with autoconf to produce a configure script.
-## 
-## $Id$
-
-AC_PREREQ(2.59)
-AC_INIT([rtems-c-src-lib-libcpu-m68k-mcf5206],[_RTEMS_VERSION],[rtems-bugs@rtems.com])
-AC_CONFIG_SRCDIR([include])
-RTEMS_TOP(../../../../../..)
-
-RTEMS_CANONICAL_TARGET_CPU
-
-AM_INIT_AUTOMAKE([no-define foreign 1.8])
-AM_MAINTAINER_MODE
-
-RTEMS_ENABLE_BARE
-RTEMS_ENV_RTEMSBSP
-
-
-RTEMS_PROJECT_ROOT
-
-RTEMS_PROG_CC_FOR_TARGET
-RTEMS_CANONICALIZE_TOOLS
-RTEMS_PROG_CCAS
-
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
-# Explicitly list all Makefiles here
-AC_CONFIG_FILES([Makefile])
-AC_OUTPUT