Index: c/src/lib/libbsp/powerpc/ep1a/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/ChangeLog	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/ep1a/ChangeLog	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -1,2 +1,7 @@
+2007-12-08	Till Straumann <strauman@slac.stanford.edu>
+
+	* Makefile.am: irq_supp.h was moved from shared/irq to
+	libcpu/powerpc/new-exceptions/bspsupport.
+
 2007-12-04	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/ep1a/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/Makefile.am	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/ep1a/Makefile.am	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -74,5 +74,6 @@
 
 ###
-include_bsp_HEADERS += ../../powerpc/shared/irq/irq.h ../../powerpc/shared/irq/irq_supp.h
+include_bsp_HEADERS += ../../powerpc/shared/irq/irq.h \
+	../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h
 
 noinst_PROGRAMS += irq.rel
Index: c/src/lib/libbsp/powerpc/ep1a/preinstall.am
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/preinstall.am	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/ep1a/preinstall.am	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -94,5 +94,5 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
 
-$(PROJECT_INCLUDE)/bsp/irq_supp.h: ../../powerpc/shared/irq/irq_supp.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+$(PROJECT_INCLUDE)/bsp/irq_supp.h: ../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq_supp.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq_supp.h
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -1,2 +1,7 @@
+2007-12-08	Till Straumann <strauman@slac.stanford.edu>
+
+	* Makefile.am: irq_supp.h was moved from shared/irq to
+	libcpu/powerpc/new-exceptions/bspsupport.
+
 2007-11-30	Till Straumann <strauman@slac.stanford.edu>
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -81,5 +81,5 @@
 
 include_bsp_HEADERS += ../../powerpc/shared/irq/irq.h \
-	../../powerpc/shared/irq/irq_supp.h
+	../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h
 
 noinst_PROGRAMS += irq.rel
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/preinstall.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/preinstall.am	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/preinstall.am	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -86,11 +86,11 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
 
+$(PROJECT_INCLUDE)/bsp/irq_supp.h: ../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq_supp.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq_supp.h
+
 $(PROJECT_INCLUDE)/bsp/motorola.h: ../../powerpc/shared/motorola/motorola.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/motorola.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/motorola.h
-
-$(PROJECT_INCLUDE)/bsp/irq_supp.h: ../shared/irq/irq_supp.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
-	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq_supp.h
-PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq_supp.h
 
 $(PROJECT_INCLUDE)/bsp/openpic.h: ../../powerpc/shared/openpic/openpic.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
Index: c/src/lib/libbsp/powerpc/psim/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/psim/ChangeLog	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/psim/ChangeLog	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -1,2 +1,7 @@
+2007-12-08	Till Straumann <strauman@slac.stanford.edu>
+
+	* Makefile.am: irq_supp.h was moved from shared/irq to
+	libcpu/powerpc/new-exceptions/bspsupport.
+
 2007-12-06	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/psim/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/psim/Makefile.am	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/psim/Makefile.am	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -63,5 +63,6 @@
 consoleio_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-include_bsp_HEADERS = irq/irq.h ../shared/irq/irq_supp.h
+include_bsp_HEADERS = irq/irq.h \
+	../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h
 
 noinst_PROGRAMS += irq.rel
Index: c/src/lib/libbsp/powerpc/psim/preinstall.am
===================================================================
--- c/src/lib/libbsp/powerpc/psim/preinstall.am	(revision b672bca70bbc361484bcf51d567660ca463a04cf)
+++ c/src/lib/libbsp/powerpc/psim/preinstall.am	(revision 7223038e1fa4bf12d73e9974645f25d6f7cade92)
@@ -70,5 +70,5 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
 
-$(PROJECT_INCLUDE)/bsp/irq_supp.h: ../shared/irq/irq_supp.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+$(PROJECT_INCLUDE)/bsp/irq_supp.h: ../../../libcpu/@RTEMS_CPU@/@exceptions@/bspsupport/irq_supp.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/irq_supp.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq_supp.h